// task name is numbering

#include <bits/stdc++.h>

#define ONLINE

using namespace std;

int main()
{
    #ifdef ONLINE
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    #endif // ONLINE
    string s;
    getline(cin,s);
    vector<int> used(10);
    for(int i=0; i<s.length(); i++){
        if(s[i]!=' '){
            used[s[i]-'0']=1;
        }
    }
    vector<int> num(10);
    int k=0;
    for(int i=0; i<10; i++){
        if(!used[i])
            num[i]=k++;
    }
    string n;
    getline(cin,n);
    if(k==1){
        cout << n.length()-1;
        return 0;
    }
    long long ans=0;
    for(int i=0; i<n.size(); i++){
        int c=n[i]-'0';
        ans=ans*k+num[c];
    }
    if(used[0]){
        long long pw=1;
        for(int i=0; i<n.length(); i++){
            ans+=pw;
            pw*=k;
        }
        ans--;
    }
    cout << ans;
    return 0;
}
